import numpy as np
from amplify import (
    IsingPoly,
    Solver,
    SymbolGenerator,
    sum_poly,
)
from amplify.client import FixstarsClient

# 分割する数を10個用意（サンプル・データ）
numbers = np.random.randint(0,100,10)

# 決定変数
gen = SymbolGenerator(IsingPoly)
s = gen.array(10)

# 目的関数
f = (sum_poly(s*numbers))**2

# イジング・マシンの設定
client = FixstarsClient()
client.token = "xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx"
client.parameters.timeout = 1000

# D-waveを使用する場合は21～23行目をコメントアウトする．代わりに
# 27～33行目のコメントアウトを外して実行する
# from amplify.client.ocean import DWaveSamplerClient

# # イジングマシンの設定
# client = DWaveSamplerClient()
# client.token = "xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx"
# client.solver = "Advantage_system4.1"
# client.parameters.num_reads = 100  # 実行回数

# イジング・マシンの実行
solver = Solver(client)
results = solver.solve(f)

# 計算結果の整形
groups = s.decode(results[0].values)

# 結果の出力
print("GroupA:", numbers[groups > 0])
print("GroupB:", numbers[groups < 0])
print("energy:", results[0].energy)